#!/usr/bin/env python

import time
import os
import sys
import urllib2
from lxml import etree

class WebResource:
    def __init__(self):
        pass

    def get(self, resource, cached, etag):
        status=200
        message=""
        request = urllib2.Request(resource)
        if etag:
            request.add_header('If-None-Match', etag)
        request.add_header('User-Agent', "k3watch/1.0 +http://wa5znu.org/2008/02/k3watch/")

        try:
            response = urllib2.urlopen(request)
        except urllib2.URLError, e:
            if hasattr(e, 'code'):
                status=e.code
            if hasattr(e, 'reason'):
                message=e.reason
        if (status == 200):
            etag = response.headers.get('ETag')
            data = response.read()
            s = etree.fromstring(data)
            return (s, etag)
        elif (status == 304):
            return (cached, etag)
        else:
            raise "Error from firmware site: %d" % (response.status)
